--MaxProfit = {version = '1.0a'}

--## Choco ##--

local qty_field = SellItemDialog[1][2][2][1][1][2][5][2]
local max_button = SellItemDialog[1][2][2][1][1][2][5][3]
local profit_text = SellItemDialog[1][2][2][1][1][2][4]

--enters qty in dialog and converts formatted dialog profit text to numeric value
local function get_profit(qty)
	qty_field.action(qty_field, nil, qty)
	local str = profit_text.title
	local profit_str, val_str = string.match(str, "Total (%a+): \127%x%x%x%x%x%x(.+) c")
	local val = val_str:gsub(",","") --remove commas, only want to pass first return value to tonumber
	val = tonumber(val)
	return (profit_str=='profit' and 1 or -1)*val --negative if text is loss
end

--return sell qty that yeilds max profit by manipulating dialog controls
--note: search algorithm stops when it finds that increasing the qty by 1 does not increase profit
--not necessarily true max profit but close enough
local function get_max_profit_qty()
	local min = {qty=1}
	local max = {}
	local mid = nil
	
	max_button:action() --fills max qty in text field
	max.qty = tonumber(qty_field.value)
	
	if max.qty <= 1 then return 1 end
	
	min.profit = get_profit(min.qty)
	max.profit = get_profit(max.qty)
	
	while true do
		mid = {qty=math.floor((min.qty+max.qty)/2)}
		--console_print((min.qty or 'nil')..' '..(mid.qty or 'nil')..' '..(max.qty or 'nil')) --debug
		if mid.qty <= min.qty then break end	--Exit Loop
		
		mid.profit = get_profit(mid.qty)
		local prev_profit = get_profit(mid.qty - 1)
		
		if prev_profit >= mid.profit then
			max = {qty=mid.qty-1, profit=prev_profit}
		else min = mid end		
	end
	
	if min.profit > max.profit then return min.qty else return max.qty end
end

local profit_button = iup.stationbutton{title="Max Profit"} --button to add to dialog
function profit_button:action()
	local max_profit_qty = get_max_profit_qty()
	
	qty_field.value = max_profit_qty --update text field qty
	qty_field:action(nil, max_profit_qty) --cause profit text to update
end

iup.Append(SellItemDialog[1][2][2][1][1][2][5], iup.fill{size=2})
iup.Append(SellItemDialog[1][2][2][1][1][2][5], profit_button)
